
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android拍照或从图库选择图片并裁剪_Android / iVAN</title>

    <meta name="description" content="Android拍照或从图库选择图片并裁剪_Android 今天看&lt;第一行代码&gt;上面关于拍照和从相册选取图片那一部分,发现始终出不来效果,所以搜索其他资料学习一下相关知识,写一个简单的Demo.  一. 拍照选择图片 1.使用隐式Intent启动相机 //构建隐式Intent Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE); //调用系统相机 startActivityForResult(intent, 1); 2.处理相机拍照返回的结果 //用户点击了取消 if(dat ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android拍照或从图库选择图片并裁剪_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>今天看《第一行代码》上面关于拍照和从相册选取图片那一部分，发现始终出不来效果，所以搜索其他资料学习一下相关知识，写一个简单的Demo。 </p>
<p><strong>一、 拍照选择图片</strong></p>
<p>1、使用隐式Intent启动相机</p>
<pre>
//构建隐式Intent
Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
//调用系统相机
startActivityForResult(intent, 1);
</pre>
<p>2、处理相机拍照返回的结果</p>
<pre>
//用户点击了取消
if(data == null){
  return;
}else{
  Bundle extras = data.getExtras();
  if (extras != null){
    //获得拍的照片
    Bitmap bm = extras.getParcelable("data");
  }
}
</pre>
<p><strong>二、 从图库选择图片</strong></p>
<p>1、构建内容选择隐式Intent</p>
<p>Intent intent = new Intent(Intent.ACTION_GET_CONTENT);</p>
<p>2、设置内容类型为图片</p>
<p>intent.setType("image/*");</p>
<p>3、启动图片选择</p>
<p>startActivityForResult(intent, 2);</p>
<p>4、处理图片选择结果</p>
<pre>
if (data == null){
  return;
}else{
  //用户从图库选择图片后会返回所选图片的Uri
  Uri uri;
  //获取到用户所选图片的Uri
  uri = data.getData();
}
</pre>
<p><strong>三、 裁剪选择的图片</strong></p>
<p>从相机拍照得到的是Bitmap类型，所以我们需要先将其转化为文件Uri以供裁剪。同时我们还要顺便将相机拍的照片保存到本地。</p>
<pre>
 /**
 * 将Bitmap写入SD卡中的一个文件中,并返回写入文件的Uri
 * @param bm
 * @param dirPath
 * @return
 */
private Uri saveBitmap(Bitmap bm, String dirPath) {
  //新建文件夹用于存放裁剪后的图片
  File tmpDir = new File(Environment.getExternalStorageDirectory() + "/" + dirPath);
  if (!tmpDir.exists()){
    tmpDir.mkdir();
  }

  //新建文件存储裁剪后的图片
  File img = new File(tmpDir.getAbsolutePath() + "/avator.png");
  try {
    //打开文件输出流
    FileOutputStream fos = new FileOutputStream(img);
    //将bitmap压缩后写入输出流(参数依次为图片格式、图片质量和输出流)
    bm.compress(Bitmap.CompressFormat.PNG, 85, fos);
    //刷新输出流
    fos.flush();
    //关闭输出流
    fos.close();
    //返回File类型的Uri
    return Uri.fromFile(img);
  } catch (FileNotFoundException e) {
    e.printStackTrace();
    return null;
  } catch (IOException e) {
    e.printStackTrace();
    return null;
  }
}
</pre>
<p>从图库选择的图片返回的是content类型的Uri，我们需要转化为文件类型的Uri才能进行裁剪。</p>
<pre>
 /**
* 将content类型的Uri转化为文件类型的Uri
* @param uri
* @return
*/
private Uri convertUri(Uri uri){
  InputStream is;
  try {
    //Uri ----&gt; InputStream
    is = getContentResolver().openInputStream(uri);
    //InputStream ----&gt; Bitmap
    Bitmap bm = BitmapFactory.decodeStream(is);
    //关闭流
    is.close();
    return saveBitmap(bm, "temp");
  } catch (FileNotFoundException e) {
    e.printStackTrace();
    return null;
  } catch (IOException e) {
    e.printStackTrace();
    return null;
  }

}
</pre>
<p>下面便是设置裁剪的参数，用隐式Intent方式启动裁剪程序</p>
<pre>
 /**
 * 通过Uri传递图像信息以供裁剪
 * @param uri
 */
private void startImageZoom(Uri uri){
  //构建隐式Intent来启动裁剪程序
  Intent intent = new Intent("com.android.camera.action.CROP");
  //设置数据uri和类型为图片类型
  intent.setDataAndType(uri, "image/*");
  //显示View为可裁剪的
  intent.putExtra("crop", true);
  //裁剪的宽高的比例为1:1
  intent.putExtra("aspectX", 1);
  intent.putExtra("aspectY", 1);
  //输出图片的宽高均为150
  intent.putExtra("outputX", 150);
  intent.putExtra("outputY", 150);
  //裁剪之后的数据是通过Intent返回
  intent.putExtra("return-data", true);
  startActivityForResult(intent, CROP_CODE);
}
</pre>
<p>下面是完整的布局文件和java文件</p>
<p>--------------------------------------------------------------------------------</p>
<p>activity_main.xml文件</p>
<pre>
&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
  android:layout_width="match_parent"
  android:layout_height="match_parent"
  android:orientation="vertical"&gt;

  &lt;ImageView
    android:id="@+id/show_image"
    android:layout_width="match_parent"
    android:layout_height="300dp"/&gt;
  &lt;Button
    android:id="@+id/choose_camera"
    android:layout_width="match_parent"
    android:layout_height="wrap_content"
    android:text="摄像头"/&gt;
  &lt;Button
    android:id="@+id/choose_gallery"
    android:layout_width="match_parent"
    android:layout_height="wrap_content"
    android:text="相册"/&gt;
&lt;/LinearLayout&gt;
</pre>
<p>MainActivity.java文件</p>
<pre>
public class MainActivity extends AppCompatActivity implements View.OnClickListener {
  //用于展示选择的图片
  private ImageView mImageView;

  private static final int CAMERA_CODE = 1;
  private static final int GALLERY_CODE = 2;
  private static final int CROP_CODE = 3;

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);

    initView();
  }

  private void initView() {
    mImageView = (ImageView) findViewById(R.id.show_image);
    Button chooseCamera = (Button) findViewById(R.id.choose_camera);
    chooseCamera.setOnClickListener(this);
    Button chooseGallery = (Button) findViewById(R.id.choose_gallery);
    chooseGallery.setOnClickListener(this);
  }

  @Override
  public void onClick(View view) {
    switch (view.getId()){
      case R.id.choose_camera:
        //拍照选择
        chooseFromCamera();
        break;
      case R.id.choose_gallery:
        //从相册选取
        chooseFromGallery();
        break;
      default:
        break;
    }
  }

  /**
   * 拍照选择图片
   */
  private void chooseFromCamera() {
    //构建隐式Intent
    Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
    //调用系统相机
    startActivityForResult(intent, CAMERA_CODE);
  }

  /**
   * 从相册选择图片
   */
  private void chooseFromGallery() {
    //构建一个内容选择的Intent
    Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
    //设置选择类型为图片类型
    intent.setType("image/*");
    //打开图片选择
    startActivityForResult(intent, GALLERY_CODE);
  }

  @Override
  protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    switch (requestCode){
      case CAMERA_CODE:
        //用户点击了取消
        if(data == null){
          return;
        }else{
          Bundle extras = data.getExtras();
          if (extras != null){
            //获得拍的照片
            Bitmap bm = extras.getParcelable("data");
            //将Bitmap转化为uri
            Uri uri = saveBitmap(bm, "temp");
            //启动图像裁剪
            startImageZoom(uri);
          }
        }
        break;
      case GALLERY_CODE:
        if (data == null){
          return;
        }else{
          //用户从图库选择图片后会返回所选图片的Uri
          Uri uri;
          //获取到用户所选图片的Uri
          uri = data.getData();
          //返回的Uri为content类型的Uri,不能进行复制等操作,需要转换为文件Uri
          uri = convertUri(uri);
          startImageZoom(uri);
        }
        break;
      case CROP_CODE:
        if (data == null){
          return;
        }else{
          Bundle extras = data.getExtras();
          if (extras != null){
            //获取到裁剪后的图像
            Bitmap bm = extras.getParcelable("data");
            mImageView.setImageBitmap(bm);
          }
        }
        break;
      default:
        break;
    }
  }

  /**
   * 将content类型的Uri转化为文件类型的Uri
   * @param uri
   * @return
   */
  private Uri convertUri(Uri uri){
    InputStream is;
    try {
      //Uri ----&gt; InputStream
      is = getContentResolver().openInputStream(uri);
      //InputStream ----&gt; Bitmap
      Bitmap bm = BitmapFactory.decodeStream(is);
      //关闭流
      is.close();
      return saveBitmap(bm, "temp");
    } catch (FileNotFoundException e) {
      e.printStackTrace();
      return null;
    } catch (IOException e) {
      e.printStackTrace();
      return null;
    }
  }

  /**
   * 将Bitmap写入SD卡中的一个文件中,并返回写入文件的Uri
   * @param bm
   * @param dirPath
   * @return
   */
  private Uri saveBitmap(Bitmap bm, String dirPath) {
    //新建文件夹用于存放裁剪后的图片
    File tmpDir = new File(Environment.getExternalStorageDirectory() + "/" + dirPath);
    if (!tmpDir.exists()){
      tmpDir.mkdir();
    }

    //新建文件存储裁剪后的图片
    File img = new File(tmpDir.getAbsolutePath() + "/avator.png");
    try {
      //打开文件输出流
      FileOutputStream fos = new FileOutputStream(img);
      //将bitmap压缩后写入输出流(参数依次为图片格式、图片质量和输出流)
      bm.compress(Bitmap.CompressFormat.PNG, 85, fos);
      //刷新输出流
      fos.flush();
      //关闭输出流
      fos.close();
      //返回File类型的Uri
      return Uri.fromFile(img);
    } catch (FileNotFoundException e) {
      e.printStackTrace();
      return null;
    } catch (IOException e) {
      e.printStackTrace();
      return null;
    }

  }

  /**
   * 通过Uri传递图像信息以供裁剪
   * @param uri
   */
  private void startImageZoom(Uri uri){
    //构建隐式Intent来启动裁剪程序
    Intent intent = new Intent("com.android.camera.action.CROP");
    //设置数据uri和类型为图片类型
    intent.setDataAndType(uri, "image/*");
    //显示View为可裁剪的
    intent.putExtra("crop", true);
    //裁剪的宽高的比例为1:1
    intent.putExtra("aspectX", 1);
    intent.putExtra("aspectY", 1);
    //输出图片的宽高均为150
    intent.putExtra("outputX", 150);
    intent.putExtra("outputY", 150);
    //裁剪之后的数据是通过Intent返回
    intent.putExtra("return-data", true);
    startActivityForResult(intent, CROP_CODE);
  }
}
</pre>
<p>注:最后还需要在AndroidManifest文件中加入存储卡读写权限</p>
<p><u>复制代码</u> 代码如下:</p>
<p>&lt;uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE"/&gt;<br />
&lt;uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/&gt;</p>
<p>以上就是本文的全部内容，希望对大家的学习有所帮助，也希望大家多多支持。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索android拍照<br />
                                    Android裁剪图片<br />
                                    android 拍照裁剪、android 拍照裁剪上传、android 拍照相册裁剪、android 拍照裁剪demo、android拍照裁剪 旋转，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:13:13</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android%e6%8b%8d%e7%85%a7/" title="android拍照">android拍照</a>, <a href="https://www.iamivan.net/tag/android%e8%a3%81%e5%89%aa%e5%9b%be%e7%89%87/" title="Android裁剪图片">Android裁剪图片</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android拍照或从图库选择图片并裁剪_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M69D7Ob.html" rel="bookmark">Android拍照或从图库选择图片并裁剪</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天看&lt;第一行代码&gt;上面关于拍照和从相册选取图片那一部分,发现始终出不来效果,所以搜索其他资料学习一下相关知识,写一个简单的Demo. 一. 拍照选择图片 1.使用隐式Intent启动相机 //构建隐式Intent Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE); //调用系统相机 startActivityForResult(intent, 1); 2.处理相机拍照返回的结果 //用户点击了取消 if(data == n			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pke9W5b.html" rel="bookmark">android 如何调用系统图库选择图片的时候，可以禁止选择视频</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android 如何调用系统图库选择图片的时候,可以禁止选择视频 onenote就是这样,选择视频的时候提示抱歉只能选择图片,这样的如何实现? 解决方案 Android4.4系统从图库选择图片android 调用图库并显示选择的图片Android 如何从系统图库中选择图片			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7Y84p.html" rel="bookmark">Android实现拍照、选择图片并裁剪图片功能&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 实现拍照.选择图片并裁剪图片效果 按照之前博客的风格,首先看下实现效果.      二. uCrop项目应用 想起之前看到的Yalantis/uCrop效果比较绚,但是研究源码之后发现在定制界面方面还是有一点的限制,于是在它的基础上做了修改Android-Crop,把定制界面独立出来,让用户去自由设置.下图为使用Android-Crop实现的模仿微信选择图片并裁剪Demo.     三. 实现思路 比较简单的选择设备图片裁剪,并将裁剪后的图片保存到指定路径: 调用系统拍照,将拍照图片保存在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDyBllb.html" rel="bookmark">Android实现拍照、选择图片并裁剪图片功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 实现拍照.选择图片并裁剪图片效果 按照之前博客的风格,首先看下实现效果. 二. uCrop项目应用 想起之前看到的Yalantis/uCrop效果比较绚,但是研究源码之后发现在定制界面方面还是有一点的限制,于是在它的基础上做了修改Android-Crop,把定制界面独立出来,让用户去自由设置.下图为使用Android-Crop实现的模仿微信选择图片并裁剪Demo. 三. 实现思路 比较简单的选择设备图片裁剪,并将裁剪后的图片保存到指定路径: 调用系统拍照,将拍照图片保存在SD卡,然后裁剪图			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmBq6b.html" rel="bookmark">android webview file事件响应 选择图片过程中退出的话 按钮点不了</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android webview file事件响应 选择图片过程中退出的话 按钮点不了 public void onActivityResult(int requestCode int resultCode Intent data) { if(requestCode==REQUEST_UPLOAD_FILE_CODE) { if (null == mUploadFile) return; Uri result = data == null || resultCode != -1 ? nu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNDDQp.html" rel="bookmark">Android设置拍照或者上传本地图片的示例&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几天,我们客户端这边收到了市场部的一个需求,需要在我们订单成交后,我们的客户端有一个上传交易凭证的功能,那么如何在Android实现上传图片的这个功能呢?在我进行编码之前,我先问自己几个问题. 第一, 图片是直接选择图库里的,还是需要拍照和选择图片两个选项? 因为在选择图片的时候,会有一个拍照的按钮,也可以实现拍照的功能. 第二, 需不需要本地缓存? 本地缓存值得是,在我们的图片上传后,是否在下次直接显示,而不是从服务器读取. 第三,图片是否需要压缩? 众所周知,图片这种资源,因为体积较大,在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj8rO0p.html" rel="bookmark">activity-Fragment（碎片）怎样实现从图库选择图片作为壁纸</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Fragment(碎片)怎样实现从图库选择图片作为壁纸 没有继承Activity而是Fragment,Activity的好多方法Fragment不能用.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5QYaRp.html" rel="bookmark">Android实现ListView异步加载图片的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android实现ListView异步加载图片的方法.分享给大家供大家参考.具体如下: ListView异步加载图片是非常实用的方法,凡是是要通过网络获取图片资源一般使用这种方法比较好,用户体验好,不用让用户等待下去,下面就说实现方法,先贴上主方法的代码: package cn.wangmeng.test; import java.io.IOException; import java.io.InputStream; import java.lang.ref.SoftReferen			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkdV9M.html" rel="bookmark">Android中TextView显示插入的图片实现方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android中TextView显示插入的图片实现方法.分享给大家供大家参考,具体如下: Android系统默认给TextView插入图片提供了三种方式: 1.ImageSpan 2.Html.ImageGetter 3.TextView.setCompoundDrawables(left, top, right, bottom) 1.TextView使用ImageSpan显示图片 ImageSpan span = new ImageSpan(this, R.drawable.ic			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrD6yz.html" rel="bookmark" class="title">从丁磊的成功经历中你学习到什么？</a>
					<div>
						1.兴趣 丁磊从小就喜欢无线电,很大程度上,他是受了父亲的影响,他认为自己将来最骄傲的职业,就是成为一个电子或者电气工程师.高考时,他填报了成都电子科技大学. 2.思考 丁磊说过,大学四年最大的收获就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP4nlp.html" rel="bookmark" class="title">加快 DHTML 的一组技巧</a>
					<div>
						dhtml|技巧 摘要:本文说明了某些 DHTML 功能对性能的重大影响,并提供了一些提高 DHTML 页面性能的技巧. 目录 简介成批处理 DHTML 更改使用 innerText使用 DOM 添加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgvwmb.html" rel="bookmark" class="title">浅淡如何用ASP实现在线人数统计</a>
					<div>
						统计|在线|在线人数                 浅淡如何用ASP实现在线人数统计                           (jaklin  2000.8.17)     我发现这几天 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMg86Zp.html" rel="bookmark" class="title">一个外链少收录少权重高站点的猜想</a>
					<div>
						现在做网站的人太多,各种各样的站点,各种各样的怪现象.站长们都在感叹网站不好做,排名难提升,但总有些站点以特别的状态展示出来,让咱们羡慕嫉妒恨.今天发现的一个站就很神奇,为什么说它神奇呢?域名年龄才1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL19Zb.html" rel="bookmark" class="title">Photoshop给草地上的人物加上暗黄色霞光</a>
					<div>
						  素材图片背景非常杂乱,处理的时候可以把背景适当模糊处理;然后把主色转为暖色,天空部分增加霞光素材;再把整体大幅压暗,局部渲染一些暖色高光即可. 原图 最终效果 1.打开原图素材大图,按Ctrl + ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElvkLz.html" rel="bookmark" class="title">Windows 8任务管理器详解</a>
					<div>
						Windows系统任务管理器,大家应该都不陌生了.估计更多的朋友是当执行程序时遇到卡死而不得不通过 Ctrl+Alt+Delete 启动任务管理器去结束程序,另外就是通过任务管理器来查看当前系统的资源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8j103b.html" rel="bookmark" class="title">浅析Ruby中的类对象的概念</a>
					<div>
						  这篇文章主要介绍了Ruby中的类对象的概念,是Ruby学习当中的基础知识,需要的朋友可以参考下 面向对象的程序涉及类和对象. 一个类是蓝本,从个别对象被创建.在面向对象的术语,我们说小明的自行车是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWYmPp.html" rel="bookmark" class="title">Windows 8如何更新设备的驱动程序</a>
					<div>
						Win8系统更新某一设备的驱动程序的方法如下: 1.右键单击桌面空白处,桌面下方弹出&quot;所有应用&quot;选项,左键单击&quot;所有应用&quot;. 2.左键单击&quot;控制面板& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badaKXz.html" rel="bookmark" class="title">JS删除字符串中重复字符方法</a>
					<div>
						 这篇文章主要介绍了JS如何删除字符串中重复字符,需要的朋友可以参考下  代码如下: &lt;!DOCTYPE html&gt;  &lt;html&gt;  &lt;head&gt;  &lt;sc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72a15p.html" rel="bookmark" class="title">数组元素并发交换问题</a>
					<div>
						前几天在论坛上看到一个有意思的问题: 有一个数组a[1000],写一个函数实现其任两个数据交换,要求并发. 比如a[1]和a[99]交换的同时a[2]和a[3]也能同时交换而不冲突,但a[1]和和其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQxe8p.html" rel="bookmark" class="title">使用 ES6 编写更好的 JavaScript Part II：深入探究 &lbrack;类&rsqb;</a>
					<div>
						本文讲的是使用 ES6 编写更好的 JavaScript Part II:深入探究 [类], 在本文的开始,我们要说明一件事: 从本质上说,ES6 的 classes 主要是给创建老式构造函数提供了一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N6arM.html" rel="bookmark" class="title">什么是好的用户体验 分析用户体验的两个维度</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 编辑注记: 在极客公园&quot;设计的力量&quot;线下活动中,极客公园创始人张鹏曾经与嘉宾讨论了&quot;什么是好的用户体验,怎样衡量好的用户体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lvBKb.html" rel="bookmark" class="title">PDF阅读器Acrobat将收费每月14&period;99美元</a>
					<div>
						6月17日消息,Adobe公司日前表示,其Acrobat.com已经结束公共测试阶段,接下来将会以计费形式向用户提供这款热门PDF阅读器软件Acrobat. 据国外媒体报道,Adobe表示,将会向用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGA5BvM.html" rel="bookmark" class="title">C&plus;&plus;的argc和argv的问题</a>
					<div>
						问题描述 C++的argc和argv的问题 int main(int argc, char *argv[]) { argc=2; if (argc&lt;2) { cout &lt;&lt; &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRyLBz.html" rel="bookmark" class="title">python &lowbar;、&lowbar;&lowbar;和&lowbar;&lowbar;xx&lowbar;&lowbar;的区别</a>
					<div>
						本文为译文,版权属于原作者,在此翻译为中文分享给大家.英文原文地址:Difference between _, __ and __xx__ in Python &quot;_&quot;单下划线 Py ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rBd8p.html" rel="bookmark" class="title">java 执行linux命令判断某个文件是否存在</a>
					<div>
						问题描述 java 执行linux命令判断某个文件是否存在 java用sshxcute 连接linux服务器,判断一个某个路径下的某个文件或文件夹是否存在? 给出返回值. 解决方案 http://ww ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRK73b.html" rel="bookmark" class="title">jquery ajax 应用实例代码</a>
					<div>
						jquery ajax 应用实例代码 /*  ajax 向页面发送数据                 $.post('save.cgi', {     text: 'my string',      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKyKDb.html" rel="bookmark" class="title">看过来：教你解决Vista无法收邮件问题</a>
					<div>
						日前有个朋友买了个 预装VISTA的本本,由于工作需要使用OUTLOOK来收邮件,在VISTA上OUTLOOK升级为Windows Mail,遇到一个很奇怪的问题,当收有附件的邮件时进度条就停止在 那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXq1Jvz.html" rel="bookmark" class="title">医疗商务通弹窗吸引用户点击的要素</a>
					<div>
						医疗网站商务通弹窗这个大家都知道,弹窗的时间.窗口的设计.弹窗的位置都是影响顾客点击的因素,而频繁的弹出商务通,提升了咨询, 却降低了用户体验. 试想一下,看一篇文章都要弹出好几次对话框真的就是能让人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRXw3b.html" rel="bookmark" class="title">苹果向谷歌发起广告战：iOS9屏蔽广告 出版商受伤</a>
					<div>
						北京时间1月2日消息,当苹果宣布推出新的iOS9移动操作系统时,它增加了一个名为&quot;内容屏蔽Safari扩展插件&quot;的功能,此功能没有引起多少人的关注.7月苹果CEO库克正式推出iOS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgLrqb.html" rel="bookmark" class="title">《智能路由器开发指南》&mdash;&mdash;1&period;3　开源嵌入式操作系统比较</a>
					<div>
						1.3 开源嵌入式操作系统比较 开源嵌入式操作系统,其字面意思有3点,即开放源代码.嵌入式和操作系统,但实质上其流行的关键在于其可扩展性. 开源是指开放源代码,是指软件在开放源代码许可证下发布软件,保 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq7V6p.html" rel="bookmark" class="title">排序算法之鸡尾酒排序</a>
					<div>
						鸡尾酒排序      鸡尾酒排序实际上是一种双向的冒泡排序.第一趟,从0开始到size-1前往后做&quot;冒泡&quot;,将最大值移动到最后(下标为size-1).第二趟,从size-2开始到0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60NgLz.html" rel="bookmark" class="title">C&plus;&plus;构造函数可向父类或者本类传参</a>
					<div>
						前面我们学习了C ++使用初始化列表的方式初始化字段: http://blog.csdn.net/morixinguan/article/details/74331335 这一节的原理和前面的差不多. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RRaqz.html" rel="bookmark" class="title">链表 算法-基于链表的算法分析之增删查改</a>
					<div>
						问题描述 基于链表的算法分析之增删查改 在链表描述中,集合中的元素都放在链表的节点中进行描述.链表中的节点不是一个数组元素,因此不能通过公式来映射定位某个元素.取而代之的是,每个节点中都包含了下一个节 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myea3vM.html" rel="bookmark" class="title">Rowhammer RAM 攻击已延伸至闪存</a>
					<div>
						本文讲的是 Rowhammer RAM 攻击已延伸至闪存,IBM的科学家将谷歌发现的DRAM位翻转攻击方法Rowhammer应用到了MLC NAND闪存上. 谷歌Project Zero在2015年发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjJdrM.html" rel="bookmark" class="title">asp net水晶报表-asp&period;net水晶报表中的图片自适应问题</a>
					<div>
						问题描述 asp.net水晶报表中的图片自适应问题 在asp.net水晶报表中插入图片字段,此字段为Image类型,但是存放的图片大小不一致,如何才能让此图片在报表中自适应?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J3xNz.html" rel="bookmark" class="title">请教怎么防止支付后网银或者支付宝多次回发</a>
					<div>
						问题描述 最近在做支付,但是遇到了一个问题,不管是支付宝还是其他网银支付,付款成功后,他们都会发多次结果,支付宝和银联或招行支付,都要连续发5次支付结果来,然后我后台就处理五次支付结果,这样照成了我多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOn319p.html" rel="bookmark" class="title">小而美的营销途径就是做好自己独有的特色</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 最近一直听&quot;小而美&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlNl8p.html" rel="bookmark" class="title">2&period;77亿收购页游公司凤凰传媒数字化转型加速</a>
					<div>
						继上月底完成首笔手游资产收购后,凤凰传媒(行情,问诊) (601928,收盘价12.86元)又将收购的触角伸向了页游公司.今日,凤凰传媒公告披露,下属子公司凤凰数字传媒拟以2.77亿元收购上海都玩网络 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKWVvz.html" rel="bookmark" class="title">收集的一些常用java正则表达式&lowbar;java</a>
					<div>
						只能输入数字:&quot;^[0-9]*$&quot;.只能输入n位的数字:&quot;^\d{n}$&quot;.只能输入至少n位的数字:&quot;^\d{n,}$&quot;.只能输入m~n位的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
